package com.sundata.internalevaluation.configuration.service;

import com.sundata.common.util.JsonUtil;
import com.sundata.internalevaluation.configuration.mapper.IndexConfigMapper;
import com.sundata.internalevaluation.configuration.model.IndexConfigModel;
import com.sundata.internalevaluation.configuration.model.IndexSourceModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class IndexConfigService {

    @Autowired
    IndexConfigMapper indexConfigMapper;

    /**
     * @author: 张艳杰
     * @methodsName: getDataList
     * @description: 指标配置初始化
     * @param: IndexConfigModel model
     * @return: List<IndexConfigModel>
     * @throws:
     */
    public List<IndexConfigModel> getDataList(IndexConfigModel model) {
        return indexConfigMapper.getDataList(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: createData
     * @description: 指标配置新增
     * @param: IndexConfigModel model
     * @return:
     * @throws:
     */
    public void createData(IndexConfigModel model) {
        String dataSet = JsonUtil.toJSONString(model.getDataSets());
        model.setDataSet(dataSet);
        indexConfigMapper.createData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: deleteRows
     * @description: 指标配置删除
     * @param: IndexConfigModel model
     * @return:
     * @throws:
     */
    public void deleteRows(IndexConfigModel model) {
        indexConfigMapper.deleteRows(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: updateExistData
     * @description: 指标配置修改
     * @param: IndexConfigModel model
     * @return:
     * @throws:
     */
    public void updateExistData(IndexConfigModel model) {
        indexConfigMapper.updateExistData(model);
    }

    /**
     * @author: 张艳杰
     * @methodsName: selectDetailData
     * @description: 指标配置查询
     * @param: IndexConfigModel model
     * @return:
     * @throws:
     */
    public IndexConfigModel selectDetailData(IndexConfigModel model) {
        IndexConfigModel selectDataSet = indexConfigMapper.selectDetailData(model);
        List<String> dataset = JsonUtil.jsonToList(selectDataSet.getDataSet());
        selectDataSet.setDataSets(dataset);
        return selectDataSet;
    }

    public List<IndexSourceModel> getIndexSourceList(IndexConfigModel indexConfigModel) {
        return indexConfigMapper.getIndexSourceList(indexConfigModel);
    }

    public List<IndexConfigModel> selectIndexListByRuleNo(String ruleNo) {
        return indexConfigMapper.selectIndexListByRuleNo(ruleNo);
    }
}
